/*!
 * react-paypal-js v7.8.2 (2022-11-30T19:31:44.159Z)
 * Copyright 2020-present, PayPal, Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import e,{createContext as t,useContext as n,useRef as r,useState as o,useEffect as a,useReducer as i}from"react";var c,l,s;!function(e){e.INITIAL="initial",e.PENDING="pending",e.REJECTED="rejected",e.RESOLVED="resolved"}(c||(c={})),function(e){e.LOADING_STATUS="setLoadingStatus",e.RESET_OPTIONS="resetOptions",e.SET_BRAINTREE_INSTANCE="braintreeInstance"}(l||(l={})),function(e){e.NUMBER="number",e.CVV="cvv",e.EXPIRATION_DATE="expirationDate",e.EXPIRATION_MONTH="expirationMonth",e.EXPIRATION_YEAR="expirationYear",e.POSTAL_CODE="postalCode"}(s||(s={}));var u="data-react-paypal-script-id",d="data-client-token",f="data-user-id-token",p="data-sdk-integration-source",v="react-paypal-js",h="data-namespace",m="https://js.braintreegateway.com/web/".concat("3.84.0","/js/client.min.js"),y="https://js.braintreegateway.com/web/".concat("3.84.0","/js/paypal-checkout.min.js"),E=function(){return(E=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function P(e,t){var n={};for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&t.indexOf(r)<0&&(n[r]=e[r]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(r=Object.getOwnPropertySymbols(e);o<r.length;o++)t.indexOf(r[o])<0&&Object.prototype.propertyIsEnumerable.call(e,r[o])&&(n[r[o]]=e[r[o]])}return n}function b(e,t,n){if(n||2===arguments.length)for(var r,o=0,a=t.length;o<a;o++)!r&&o in t||(r||(r=Array.prototype.slice.call(t,0,o)),r[o]=t[o]);return e.concat(r||Array.prototype.slice.call(t))}function w(e){return void 0===e&&(e="paypal"),window[e]}function N(e){var t=e.reactComponentName,n=e.sdkComponentKey,r=e.sdkRequestedComponents,o=void 0===r?"":r,a=e.sdkDataNamespace,i=void 0===a?"paypal":a,c=n.charAt(0).toUpperCase().concat(n.substring(1)),l="Unable to render <".concat(t," /> because window.").concat(i,".").concat(c," is undefined.");if(!o.includes(n)){var s=[o,n].filter(Boolean).join();l+="\nTo fix the issue, add '".concat(n,"' to the list of components passed to the parent PayPalScriptProvider:")+"\n`<PayPalScriptProvider options={{ components: '".concat(s,"'}}>`.")}return l}function g(e){return"react-paypal-js-".concat(function(e){for(var t="",n=0;n<e.length;n++){var r=e[n].charCodeAt(0)*n;e[n+1]&&(r+=e[n+1].charCodeAt(0)*(n-1)),t+=String.fromCharCode(97+Math.abs(r)%26)}return t}(JSON.stringify(e)))}function A(e){var t=self.document.querySelector("script[".concat(u,'="').concat(e,'"]'));(null==t?void 0:t.parentNode)&&t.parentNode.removeChild(t)}function I(e,t){var n;switch(t.type){case l.LOADING_STATUS:return E(E({},e),{loadingStatus:t.value});case l.RESET_OPTIONS:return A(e.options[u]),delete t.value[u],E(E({},e),{loadingStatus:c.PENDING,options:E(E({},t.value),(n={},n[u]="".concat(g(t.value)),n[p]=v,n))});case l.SET_BRAINTREE_INSTANCE:return E(E({},e),{braintreePayPalCheckoutInstance:t.value});default:return e}}var O=t(null);function S(e){if("function"==typeof(null==e?void 0:e.dispatch)&&0!==e.dispatch.length)return e;throw new Error("usePayPalScriptReducer must be used within a PayPalScriptProvider")}function T(){var e=S(n(O));return[E(E({},e),{isInitial:e.loadingStatus===c.INITIAL,isPending:e.loadingStatus===c.PENDING,isResolved:e.loadingStatus===c.RESOLVED,isRejected:e.loadingStatus===c.REJECTED}),e.dispatch]}function R(){var e=function(e){var t,n;if(!(null===(t=null==e?void 0:e.options)||void 0===t?void 0:t[d])&&!(null===(n=null==e?void 0:e.options)||void 0===n?void 0:n[f]))throw new Error("Invalid authorization data. Use data-client-token or data-user-id-token to authorize.");return e}(S(n(O)));return[e,e.dispatch]}var C=t({});function k(){return n(C)}var D=function(t){var n=t.className,i=void 0===n?"":n,c=t.disabled,l=void 0!==c&&c,s=t.children,u=t.forceReRender,d=void 0===u?[]:u,f=P(t,["className","disabled","children","forceReRender"]),p=l?{opacity:.38}:{},v="".concat(i," ").concat(l?"paypal-buttons-disabled":"").trim(),m=r(null),y=r(null),g=T()[0],A=g.isResolved,I=g.options,O=o(null),S=O[0],R=O[1],C=o(!0),k=C[0],j=C[1],L=o(null)[1];function F(){null!==y.current&&y.current.close().catch((function(){}))}return a((function(){if(!1===A)return F;var e=w(I[h]);if(void 0===e||void 0===e.Buttons)return L((function(){throw new Error(N({reactComponentName:D.displayName,sdkComponentKey:"buttons",sdkRequestedComponents:I.components,sdkDataNamespace:I[h]}))})),F;try{y.current=e.Buttons(E(E({},f),{onInit:function(e,t){R(t),"function"==typeof f.onInit&&f.onInit(e,t)}}))}catch(e){return L((function(){throw new Error("Failed to render <PayPalButtons /> component. Failed to initialize:  ".concat(e))}))}return!1===y.current.isEligible()?(j(!1),F):m.current?(y.current.render(m.current).catch((function(e){null!==m.current&&0!==m.current.children.length&&L((function(){throw new Error("Failed to render <PayPalButtons /> component. ".concat(e))}))})),F):F}),b(b([A],d,!0),[f.fundingSource],!1)),a((function(){null!==S&&(!0===l?S.disable().catch((function(){})):S.enable().catch((function(){})))}),[l,S]),e.createElement(e.Fragment,null,k?e.createElement("div",{ref:m,style:p,className:v}):s)};function j(e){var t="https://www.paypal.com/sdk/js";e.sdkBaseURL&&(t=e.sdkBaseURL,delete e.sdkBaseURL),function(e){var t=e["merchant-id"],n=e["data-merchant-id"],r="",o="";Array.isArray(t)?t.length>1?(r="*",o=t.toString()):r=t.toString():"string"==typeof t&&t.length>0?r=t:"string"==typeof n&&n.length>0&&(r="*",o=n);e["merchant-id"]=r,e["data-merchant-id"]=o}(e);var n=Object.keys(e).filter((function(t){return void 0!==e[t]&&null!==e[t]&&""!==e[t]})).reduce((function(t,n){var r=e[n].toString();return"data-"===n.substring(0,5)?t.dataAttributes[n]=r:t.queryParams[n]=r,t}),{queryParams:{},dataAttributes:{}}),r=n.queryParams,o=n.dataAttributes;return{url:"".concat(t,"?").concat(L(r)),dataAttributes:o}}function L(e){var t="";return Object.keys(e).forEach((function(n){0!==t.length&&(t+="&"),t+=n+"="+e[n]})),t}function F(e,t){void 0===t&&(t={});var n=document.createElement("script");return n.src=e,Object.keys(t).forEach((function(e){n.setAttribute(e,t[e]),"data-csp-nonce"===e&&n.setAttribute("nonce",t["data-csp-nonce"])})),n}function B(e,t){if(void 0===t&&(t=U()),x(e,t),"undefined"==typeof window)return t.resolve(null);var n=j(e),r=n.url,o=n.dataAttributes,a=o["data-namespace"]||"paypal",i=_(a);return function(e,t){var n=document.querySelector('script[src="'.concat(e,'"]'));if(null===n)return null;var r=F(e,t),o=n.cloneNode();if(delete o.dataset.uidAuto,Object.keys(o.dataset).length!==Object.keys(r.dataset).length)return null;var a=!0;return Object.keys(o.dataset).forEach((function(e){o.dataset[e]!==r.dataset[e]&&(a=!1)})),a?n:null}(r,o)&&i?t.resolve(i):M({url:r,attributes:o},t).then((function(){var e=_(a);if(e)return e;throw new Error("The window.".concat(a," global variable is not available."))}))}function M(e,t){void 0===t&&(t=U()),x(e,t);var n=e.url,r=e.attributes;if("string"!=typeof n||0===n.length)throw new Error("Invalid url.");if(void 0!==r&&"object"!=typeof r)throw new Error("Expected attributes to be an object.");return new t((function(e,t){if("undefined"==typeof window)return e();!function(e){var t=e.url,n=e.attributes,r=e.onSuccess,o=e.onError,a=F(t,n);a.onerror=o,a.onload=r,document.head.insertBefore(a,document.head.firstElementChild)}({url:n,attributes:r,onSuccess:function(){return e()},onError:function(){var e=new Error('The script "'.concat(n,'" failed to load.'));return window.fetch?fetch(n).then((function(n){return 200===n.status&&t(e),n.text()})).then((function(e){var n=function(e){var t=e.split("/* Original Error:")[1];return t?t.replace(/\n/g,"").replace("*/","").trim():e}(e);t(new Error(n))})).catch((function(e){t(e)})):t(e)}})}))}function U(){if("undefined"==typeof Promise)throw new Error("Promise is undefined. To resolve the issue, use a Promise polyfill.");return Promise}function _(e){return window[e]}function x(e,t){if("object"!=typeof e||null===e)throw new Error("Expected an options object.");if(void 0!==t&&"function"!=typeof t)throw new Error("Expected PromisePonyfill to be a function.")}D.displayName="PayPalButtons";var H=function(e){return e&&function(e){var t,n;if("function"!=typeof(null===(t=null==e?void 0:e.client)||void 0===t?void 0:t.create)&&"function"!=typeof(null===(n=null==e?void 0:e.paypalCheckout)||void 0===n?void 0:n.create))throw new Error("The braintreeNamespace property is not a valid BraintreeNamespace type.");return!0}(e)?Promise.resolve(e):Promise.all([M({url:m}),M({url:y})]).then((function(){return void 0===e&&(e="braintree"),window[e];var e}))},G=function(t){var n=t.className,r=void 0===n?"":n,i=t.disabled,c=void 0!==i&&i,s=t.children,u=t.forceReRender,p=void 0===u?[]:u,v=t.braintreeNamespace,h=t.merchantAccountId,m=P(t,["className","disabled","children","forceReRender","braintreeNamespace","merchantAccountId"]),y=o(null)[1],b=R(),w=b[0],N=b[1];return a((function(){H(v).then((function(e){var t=w.options[f],n=w.options[d];return e.client.create({authorization:t||n}).then((function(t){var n=h?{merchantAccountId:h}:{};return e.paypalCheckout.create(E(E({},n),{client:t}))})).then((function(e){N({type:l.SET_BRAINTREE_INSTANCE,value:e})}))})).catch((function(e){y((function(){throw new Error("".concat("Failed to load the PayPal JS SDK script."," ").concat(e))}))}))}),[w.options]),e.createElement(e.Fragment,null,w.braintreePayPalCheckoutInstance&&e.createElement(D,E({className:r,disabled:c,forceReRender:p},function(e,t){var n=e.createOrder,r=e.createBillingAgreement,o=e.onApprove;return"function"==typeof n&&(e.createOrder=function(e,r){return n(e,E(E({},r),{braintree:t}))}),"function"==typeof r&&(e.createBillingAgreement=function(e,n){return r(e,E(E({},n),{braintree:t}))}),"function"==typeof o&&(e.onApprove=function(e,n){return o(e,E(E({},n),{braintree:t}))}),E({},e)}(m,w.braintreePayPalCheckoutInstance)),s))},K=function(t){var n=t.className,i=void 0===n?"":n,c=t.children,l=P(t,["className","children"]),s=T()[0],u=s.isResolved,d=s.options,f=r(null),p=o(!0),v=p[0],m=p[1],y=o(null)[1];return a((function(){if(!1!==u){var e=w(d[h]);if(void 0===e||void 0===e.Marks)return y((function(){throw new Error(N({reactComponentName:K.displayName,sdkComponentKey:"marks",sdkRequestedComponents:d.components,sdkDataNamespace:d[h]}))}));!function(e){var t=f.current;if(!t||!e.isEligible())return m(!1);t.firstChild&&t.removeChild(t.firstChild),e.render(t).catch((function(e){null!==t&&0!==t.children.length&&y((function(){throw new Error("Failed to render <PayPalMarks /> component. ".concat(e))}))}))}(e.Marks(E({},l)))}}),[u,l.fundingSource]),e.createElement(e.Fragment,null,v?e.createElement("div",{ref:f,className:i}):c)};K.displayName="PayPalMarks";var Y=function(t){var n=t.className,i=void 0===n?"":n,c=t.forceReRender,l=void 0===c?[]:c,s=P(t,["className","forceReRender"]),u=T()[0],d=u.isResolved,f=u.options,p=r(null),v=r(null),m=o(null)[1];return a((function(){if(!1!==d){var e=w(f[h]);if(void 0===e||void 0===e.Messages)return m((function(){throw new Error(N({reactComponentName:Y.displayName,sdkComponentKey:"messages",sdkRequestedComponents:f.components,sdkDataNamespace:f[h]}))}));v.current=e.Messages(E({},s)),v.current.render(p.current).catch((function(e){null!==p.current&&0!==p.current.children.length&&m((function(){throw new Error("Failed to render <PayPalMessages /> component. ".concat(e))}))}))}}),b([d],l,!0)),e.createElement("div",{ref:p,className:i})};Y.displayName="PayPalMessages";var V=function(t){var n,r=t.options,o=void 0===r?{"client-id":"test"}:r,s=t.children,d=t.deferLoading,f=void 0!==d&&d,h=i(I,{options:E(E({},o),(n={},n[u]="".concat(g(o)),n[p]=v,n)),loadingStatus:f?c.INITIAL:c.PENDING}),m=h[0],y=h[1];return a((function(){if(!1===f&&m.loadingStatus===c.INITIAL)return y({type:l.LOADING_STATUS,value:c.PENDING});if(m.loadingStatus===c.PENDING){var e=!0;return B(m.options).then((function(){e&&y({type:l.LOADING_STATUS,value:c.RESOLVED})})).catch((function(t){console.error("".concat("Failed to load the PayPal JS SDK script."," ").concat(t)),e&&y({type:l.LOADING_STATUS,value:c.REJECTED})})),function(){e=!1}}}),[m.options,f,m.loadingStatus]),e.createElement(O.Provider,{value:E(E({},m),{dispatch:y})},s)},q=function(e){if(!e.includes(s.NUMBER)||!e.includes(s.CVV)||function(e){return!e.includes(s.EXPIRATION_DATE)&&!e.includes(s.EXPIRATION_MONTH)&&!e.includes(s.EXPIRATION_YEAR)}(e))throw new Error("To use HostedFields you must use it with at least 3 children with types: [number, cvv, expirationDate] includes")},X=function(e){q(e),function(e){if(e.length!==new Set(e).size)throw new Error("Cannot use duplicate HostedFields as children")}(e)},z=function(t){var n=t.styles,i=t.createOrder,l=t.notEligibleError,s=t.children,u=t.installments,d=R()[0],f=d.options,p=d.loadingStatus,v=o(!0),m=v[0],y=v[1],P=o(),b=P[0],N=P[1],g=o(null)[1],A=r(null),I=r(),O=function(e){void 0===e&&(e={});var t=r(e);return[t,function(e){t.current=E(E({},t.current),e)}]}(),S=O[0],T=O[1];return a((function(){var e;if(X(Object.keys(S.current)),p===c.RESOLVED){if(I.current=w(f[h]).HostedFields,!I.current)throw new Error(function(e){var t=e.components,n=void 0===t?"":t,r=e[h],o=void 0===r?"paypal":r,a=n?"".concat(n,",hosted-fields"):"hosted-fields",i="Unable to render <PayPalHostedFieldsProvider /> because window.".concat(o,".HostedFields is undefined.");return n.includes("hosted-fields")||(i+="\nTo fix the issue, add 'hosted-fields' to the list of components passed to the parent PayPalScriptProvider: <PayPalScriptProvider options={{ components: '".concat(a,"'}}>")),i}(((e={components:f.components})[h]=f[h],e)));if(!I.current.isEligible())return y(!1);b&&b.teardown(),I.current.render({createOrder:i,fields:S.current,installments:u,styles:n}).then((function(e){A.current&&N(e)})).catch((function(e){g((function(){throw new Error("Failed to render <PayPalHostedFieldsProvider /> component. ".concat(e))}))}))}}),[p,n]),e.createElement("div",{ref:A},m?e.createElement(C.Provider,{value:{cardFields:b,registerHostedField:T}},s):l)},J=function(t){var r=t.hostedFieldType,o=t.options,i=P(t,["hostedFieldType","options"]),c=n(C);return a((function(){var e;if(!(null==c?void 0:c.registerHostedField))throw new Error("The HostedField cannot be register in the PayPalHostedFieldsProvider parent component");c.registerHostedField(((e={})[r]={selector:o.selector,placeholder:o.placeholder,type:o.type,formatInput:o.formatInput,maskInput:o.maskInput,select:o.select,maxlength:o.maxlength,minlength:o.minlength,prefill:o.prefill,rejectUnsupportedCards:o.rejectUnsupportedCards},e))}),[]),e.createElement("div",E({},i))},W={PAYPAL:"paypal",VENMO:"venmo",APPLEPAY:"applepay",ITAU:"itau",CREDIT:"credit",PAYLATER:"paylater",CARD:"card",IDEAL:"ideal",SEPA:"sepa",BANCONTACT:"bancontact",GIROPAY:"giropay",SOFORT:"sofort",EPS:"eps",MYBANK:"mybank",P24:"p24",VERKKOPANKKI:"verkkopankki",PAYU:"payu",BLIK:"blik",TRUSTLY:"trustly",ZIMPLER:"zimpler",MAXIMA:"maxima",OXXO:"oxxo",BOLETO:"boleto",BOLETOBANCARIO:"boletobancario",WECHATPAY:"wechatpay",MERCADOPAGO:"mercadopago",MULTIBANCO:"multibanco"};export{G as BraintreePayPalButtons,l as DISPATCH_ACTION,W as FUNDING,s as PAYPAL_HOSTED_FIELDS_TYPES,D as PayPalButtons,J as PayPalHostedField,z as PayPalHostedFieldsProvider,K as PayPalMarks,Y as PayPalMessages,V as PayPalScriptProvider,c as SCRIPT_LOADING_STATE,O as ScriptContext,A as destroySDKScript,g as getScriptID,I as scriptReducer,k as usePayPalHostedFields,T as usePayPalScriptReducer,R as useScriptProviderContext};
